# Managed by Puppet
#
<%-
  def unbound_version
    version = @unbound_version ? @unbound_version : '0.a'
    return version
  end
  def print_config(name, value, version=false )
    if version and scope.call_function('versioncmp', [unbound_version, version]) < 0
       return
    end
    if value.is_a?(TrueClass)
      return "  #{name}: yes\n"
    elsif value.is_a?(FalseClass)
      return "  #{name}: no\n"
    elsif not value
      return
    elsif value.is_a?(String)
      return "  #{name}: \"#{value}\"\n"
    elsif value.is_a?(Integer)
      return "  #{name}: #{value}\n"
    elsif value.is_a?(Array) and !value.empty?
      str = ''
      value.each { |v| str << "  #{name}: #{v}\n" }
      return str
    end
  end
-%>
server:
<%= print_config('verbosity', @verbosity) -%>
<%= print_config('statistics-interval', @statistics_interval) -%>
<%= print_config('statistics-cumulative', @statistics_cumulative) -%>
<%= print_config('extended-statistics', @extended_statistics) -%>
<%= print_config('num-threads', @num_threads) -%>
<%= print_config('port', @port) -%>
<%= print_config('interface', @interface) -%>
<%= print_config('interface-automatic', @interface_automatic) -%>
<%= print_config('outgoing-interface', @outgoing_interface, '1.5.10') -%>
<%= print_config('outgoing-range', @outgoing_range) -%>
<%- if @outgoing_port_permit_first -%>
<%= print_config('outgoing-port-permit', @outgoing_port_permit) -%>
<%= print_config('outgoing-port-avoid', @outgoing_port_avoid) -%>
<%- else -%>
<%= print_config('outgoing-port-permit', @outgoing_port_avoid) -%>
<%= print_config('outgoing-port-avoid', @outgoing_port_permit) -%>
<%- end -%>
<%= print_config('outgoing-num-tcp', @outgoing_num_tcp) -%>
<%= print_config('incoming-num-tcp', @incoming_num_tcp) -%>
<%= print_config('edns-buffer-size', @edns_buffer_size) -%>
<%= print_config('max-udp-size', @max_udp_size) -%>
<%= print_config('stream-wait-size', @stream_wait_size, '1.9.0') -%>
<%= print_config('msg-cache-size', @msg_cache_size) -%>
<%= print_config('msg-cache-slabs', @msg_cache_slabs) -%>
<%= print_config('num-queries-per-thread', @num_queries_per_thread) -%>
<%= print_config('jostle-timeout', @jostle_timeout) -%>
<%= print_config('delay-close', @delay_close) -%>
<%= print_config('unknown-server-time-limit', @unknown_server_time_limit, '1.8.2') -%>
<%= print_config('so-rcvbuf', @so_rcvbuf) -%>
<%= print_config('so-sndbuf', @so_sndbuf) -%>
<%= print_config('so-reuseport', @so_reuseport, '1.4.22') -%>
<%= print_config('ip-transparent', @ip_transparent, '1.5.4') -%>
<%= print_config('ip-freebind', @ip_freebind, '1.5.9') -%>
<%= print_config('rrset-cache-slabs', @rrset_cache_slabs) -%>
<%= print_config('rrset-cache-size', @rrset_cache_size) -%>
<%= print_config('cache-max-ttl', @cache_max_ttl) -%>
<%= print_config('cache-max-negative-ttl', @cache_max_negative_ttl) -%>
<%= print_config('cache-min-ttl', @cache_min_ttl) -%>
<%= print_config('infra-host-ttl', @infra_host_ttl) -%>
<%= print_config('infra-cache-numhosts', @infra_cache_numhosts) -%>
<%= print_config('infra-cache-slabs', @infra_cache_slabs) -%>
<%= print_config('infra-cache-min-rtt', @infra_cache_min_rtt) -%>
<% if !@define_tag.empty? and scope.call_function('versioncmp', [unbound_version, '1.5.10']) >= 0 -%>
  define-tag: "<%= @define_tag.join(' ') %>"
<%- end -%>
<%= print_config('do-ip4', @do_ip4) -%>
<%= print_config('do-ip6', @do_ip6) -%>
<%= print_config('prefer-ip6', @prefer_ip6, '1.5.10') -%>
<%= print_config('do-udp', @do_udp) -%>
<%= print_config('do-tcp', @do_tcp) -%>
<%= print_config('tcp-mss', @tcp_mss, '1.5.8') -%>
<%= print_config('outgoing-tcp-mss', @outgoing_tcp_mss, '1.5.8') -%>
<%= print_config('tcp-idle-timeout', @tcp_idle_timeout, '1.8.0') -%>
<%= print_config('edns-tcp-keepalive', @edns_tcp_keepalive, '1.8.0') -%>
<%= print_config('edns-tcp-keepalive-timeout', @edns_tcp_keepalive_timeout, '1.8.0') -%>
<%= print_config('tcp-upstream', @tcp_upstream) -%>
<%= print_config('udp-upstream-without-downstream', @udp_upstream_without_downstream, '1.6.7') -%>
<%= print_config('tls-upstream', @tls_upstream, '1.7.0') -%>
<%= print_config('tls-cert-bundle', @tls_cert_bundle, '1.7.0') -%>
<%= print_config('ssl-upstream', @ssl_upstream, '1.7.0') -%>
<%= print_config('ssl-service-key', @ssl_service_key, '1.7.0') -%>
<%= print_config('ssl-service-pem', @ssl_service_pem, '1.7.0') -%>
<%= print_config('ssl-port', @ssl_port, '1.7.0') -%>
<%= print_config('tls-ciphers', @tls_ciphers, '1.9.0') -%>
<%= print_config('tls-ciphersuites', @tls_ciphersuites, '1.9.0') -%>
<%= print_config('use-systemd', @use_systemd, '1.6.1') -%>
<%= print_config('do-daemonize', @do_daemonize) -%>
<% @access.each do |acc| -%>
  <%- if acc.include? " " -%>
  access-control: <%= acc %>
  <%- else -%>
  access-control: <%= acc %> allow
  <%- end -%>
<%- end -%>
<%- if scope.call_function('versioncmp', [unbound_version, '1.5.10']) >= 0 -%>
  <%- @access_control.each_pair do |prefix, config| -%>
    <%- if config.include?('tags') -%>
      <%- unless config.include?('action') or config.include?('rr_string') -%>
  access-control-tag: <%= prefix %> "<%= tags.join(' ') %>"
      <%- else -%>
        <%- config['tags'].each do |tag| -%>
          <%- if config.include?('action') -%>
  access-control-tag-action: <%= prefix %> <%= tag %> <%= config['action'] %>
          <%- end -%>
          <%- if config.include?('rr_string') -%>
  access-control-tag-action: <%= prefix %> <%= tag %> <%= config['rr_string'] %>
          <%- end -%>
        <%- end -%>
      <%- end -%>
    <%- end -%>
    <%- if config.include?('view') -%>
  access-control-view: <%= prefix %> <% config['view'] %>
    <%- end -%>
  <%- end -%>
<%- end -%>
<%= print_config('chroot', @chroot) -%>
<%= print_config('username', @username) -%>
<%= print_config('directory', @directory) -%>
<% if @logfile -%>
  logfile: <%= @logfile %>
  use-syslog: no
<% else -%>
  use-syslog: yes
<% end -%>
<%= print_config('log-identity', @log_identity, '1.6.0') -%>
<%= print_config('log-time-ascii', @log_time_ascii) -%>
<%= print_config('log-queries', @log_queries) -%>
<%= print_config('log-replies', @log_replies, '1.6.1') -%>
<%= print_config('log-tag-queryreply', @log_tag_queryreply, '1.9.0') -%>
<%= print_config('log-local-actions', @log_local_actions, '1.8.0') -%>
<%= print_config('log-servfail', @log_servfail, '1.8.0') -%>
<%= print_config('hide-identity', @hide_identity) -%>
<%= print_config('pidfile', @pidfile) -%>
<%- unless @hints_file == 'builtin' -%>
<%= print_config('root-hints', @hints_file) -%>
<%- end -%>
<%= print_config('identity', @identity) -%>
<%= print_config('hide-version', @hide_version) -%>
<%= print_config('version', @version) -%>
<%= print_config('hide-trustanchor', @hide_trustanchor, '1.6.2') -%>
<%= print_config('target-fetch-policy', @target_fetch_policy) -%>
<%= print_config('harden-short-bufsize', @harden_short_bufsize) -%>
<%= print_config('harden-large-queries', @harden_large_queries) -%>
<%= print_config('harden-glue', @harden_glue) -%>
<%= print_config('harden-dnssec-stripped', @harden_dnssec_stripped) -%>
<%= print_config('harden-below-nxdomain', @harden_below_nxdomain) -%>
<%= print_config('harden-referral-path', @harden_referral_path) -%>
<%= print_config('harden-algo-downgrade', @harden_algo_downgrade, '1.5.3') -%>
<%= print_config('use-caps-for-id', @use_caps_for_id) -%>
<%= print_config('caps-whitlist', @caps_whitlist) -%>
<%= print_config('qname-minimisation', @qname_minimisation, '1.5.7') -%>
<%= print_config('qname-minimisation-strict', @qname_minimisation_strict, '1.6.0') -%>
<%= print_config('private-address', @private_address) -%>
<%= print_config('private-domain', @private_domain) -%>
<%= print_config('unwanted-reply-threshold', @unwanted_reply_threshold) -%>
<%= print_config('do-not-query-address', @do_not_query_address) -%>
<%= print_config('do-not-query-localhost', @do_not_query_localhost) -%>
<%= print_config('prefetch', @prefetch) -%>
<%= print_config('prefetch-key', @prefetch_key) -%>
<%= print_config('deny-any', @deny_any, '1.8.2') -%>
<%= print_config('rrset-roundrobin', @rrset_roundrobin) -%>
<%= print_config('minimal-responses', @minimal_responses) -%>
<%= print_config('disable-dnssec-lame-check', @disable_dnssec_lame_check, '1.5.9') -%>
<%- unless @module_config.empty? %>
  module-config: "<%= @module_config.join(' ') %>"
<%- end -%>
<%= print_config('trust-anchor-file', @trust_anchor_file) -%>
<%= print_config('auto-trust-anchor-file', @auto_trust_anchor_file) -%>
<%= print_config('trust-anchor', @trust_anchor) -%>
<%= print_config('trusted-keys-file', @trusted_keys_file) -%>
<%= print_config('trust-anchor-signaling', @trust_anchor_signaling, '1.6.4') -%>
<%= print_config('domain-insecure', @domain_insecure) -%>
<%= print_config('val-sig-skew-min', @val_sig_skew_min) -%>
<%= print_config('val-sig-skew-max', @val_sig_skew_max) -%>
<%= print_config('val-bogus-ttl', @val_bogus_ttl) -%>
<%= print_config('val-clean-additional', @val_clean_additional) -%>
<%= print_config('val-log-level', @val_log_level) -%>
<%= print_config('val-permissive-mode', @val_permissive_mode) -%>
<%= print_config('ignore-cd-flag', @ignore_cd_flag) -%>
<%= print_config('serve-expired', @serve_expired, '1.6.0') -%>
<%= print_config('serve-expired-ttl', @serve_expired_ttl, '1.8.0') -%>
<%= print_config('serve-expired-ttl-reset', @serve_expired_ttl_reset, '1.8.0') -%>
<%= print_config('serve-expired-reply-ttl', @serve_expired_reply_ttl, '1.8.0') -%>
<%= print_config('serve-expired-client-timeout', @serve_expired_client_timeout, '1.8.0') -%>
<%= print_config('val-nsec3-keysize-iterations', @val_nsec3_keysize_iterations) -%>
<%= print_config('add-holddown', @add_holddown) -%>
<%= print_config('del-holddown', @del_holddown) -%>
<%= print_config('keep-missing', @keep_missing) -%>
<%= print_config('permit-small-holddown', @permit_small_holddown, '1.5.5') -%>
<%= print_config('key-cache-size', @key_cache_size) -%>
<%= print_config('key-cache-slabs', @key_cache_slabs) -%>
<%= print_config('neg-cache-size', @neg_cache_size) -%>
<%= print_config('unblock-lan-zones', @unblock_lan_zones, '1.5.0') -%>
<%= print_config('insecure-lan-zones', @insecure_lan_zones, '1.5.8') -%>
<%- @local_zone.each_pair do |zone, type| -%>
  local-zone: "<%= zone %>" <%= type %>
<%- end -%> 
<%= print_config('local-data', @local_data) -%>
<%= print_config('local-data-ptr', @local_data_ptr) -%>
<%- if scope.call_function('versioncmp', [unbound_version, '1.5.10']) >= 0 -%>
  <%- @local_zone_tag.each_pair do |zone, tags| -%>
  local-zone-tag: <%= zone %> "<%= tags.join(' ') %>
  <%- end -%>
<%- end -%>
<%- if scope.call_function('versioncmp', [unbound_version, '1.5.10']) >= 0 -%>
  <%- @local_zone_override.each_pair do |zone, config| -%>
  local-zone-tag: <%= zone %> <%= config['netblock'] %> <%= config['type'] %>
  <%- end -%>
<%- end -%>
<%= print_config('ratelimit', @ratelimit) -%>
<%= print_config('ratelimit-size', @ratelimit_size) -%>
<%= print_config('ratelimit-slabs', @ratelimit_slabs) -%>
<%= print_config('ratelimit-factor', @ratelimit_factor) -%>
<%- @ratelimit_for_domain.each_pair do |domain, qps| %>
  ratelimit-for-domain: <%= domain %> <%= qps %>
<%- end -%>
<%- @ratelimit_below_domain.each_pair do |domain, qps| %>
  ratelimit-below-domain: <%= domain %> <%= qps %>
<%- end -%>
<%= print_config('ip-ratelimit', @ip_ratelimit, '1.6.1') -%>
<%= print_config('ip-ratelimit-size', @ip_ratelimit_size, '1.6.1') -%>
<%= print_config('ip-ratelimit-slabs', @ip_ratelimit_slabs, '1.6.1') -%>
<%= print_config('ip-ratelimit-factor', @ip_ratelimit_factor, '1.6.1') -%>
<%= print_config('fast-server-permil', @fast_server_permil, '1.8.2') -%>
<%= print_config('fast-server-num', @fast_server_num, '1.8.2') -%>
<% @custom_server_conf.each do |c| -%>
  <%= c %>
<% end -%>
